﻿using System.Linq;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.MetaOptimization {
  [StorableClass]
  public class SingleValuedParameterConfiguration : ParameterConfiguration {

    #region Constructors and Cloning
    [StorableConstructor]
    protected SingleValuedParameterConfiguration(bool deserializing) : base(deserializing) { }
    public SingleValuedParameterConfiguration(string parameterName, IValueParameter valueParameter)
      : base(parameterName, valueParameter, false) {
      this.Optimize = true;
      this.ValueConfigurations.Single().Optimize = true;
    }
    public SingleValuedParameterConfiguration() { }
    protected SingleValuedParameterConfiguration(SingleValuedParameterConfiguration original, Cloner cloner)
      : base(original, cloner) {
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new SingleValuedParameterConfiguration(this, cloner);
    }
    #endregion
  }
}
